| FoxitPDFSDKforWeb v11.0.5 Archives Foxit PDF SDK for Web

Public Member Functions | Protected Member Functions | List of all members
ContainerComponent Class Reference
UIExtension » components

An container is a component to organize widgets. You need to inherit this class and implement some necessary methods to customize your own container components.
The features that distinguish from widgets are following: More...

Inheritance diagram for ContainerComponent:

## Public Member Functions
| append (child, fragments)
| Append a component or a template into this container component. More...
| childAt (index)
| Get the specific child component at the given zero-based `index`. Returns `undefined` if the index is out of range. More...
| children ()
| Get all children of this container component. More...
| childrenCount ()
| Returns the number of children in this container component. More...
| empty ()
| Remove all children of this component.
| first ()
| Get the first child fom this container component, if there is no children, null will returned. More...
| indexOf (child)
| Get the index of an child component. More...
| insert (child, index, fragments)
| Inserts a component instance or component template. Example: pdfui.getComponentByName('home-tab-group-hand') .then(function(groupComponent) { groupComponent.insert( '<xbutton icon-class="fv__icon-toolbar-hand" name="insert-button-name"></xbutton>', 0, [{ target: 'insert-button-name', config: { callback: function() { alert('button clicked'); } } }] ); }) . More...
| insertAll (children, index)
| Inserts a set of components to the specified index. More...
| last ()
| Get the last child from this container component. More...
| prepend (child, fragments)
| Prepend a component or a template into this container component. More...
| removeChild (child)
| Remove a child from this component and trigger UIExtension.UIConsts.COMPONENT_EVENTS.REMOVED event;. More...
| size ()
| The number of children in this container component. More...
Public Member Functions inherited from Component
| active ()
| Actives the component, and set `isActive` property to true, this method triggers UIExtension.UIConsts.COMPONENT_EVENTS.ACTIVE event. More...
| addDestroyHook (...hooks)
| Add a function to destroyHooks list, which will be called during destroy. More...
| after (component, fragments)
| Inserts this component after the specified component. More...
| attachEventToElement (element, types, listener, options)
| Binds single or more DOM events of the specified type to the specified element. This or these events are automatically removed when the element component is destroyed. More...
| before (component, fragments)
| Insert this component before the specified component. More...
| deactive ()
| Deactives the component, and set `isActive` property to false, this method triggers UIExtension.UIConsts.COMPONENT_EVENTS.DEACTIVE event. More...
| destroy ()
| Destroy the component and remove from its parent. this method triggers UIExtension.UIConsts.COMPONENT_EVENTS.DESTROYED event. More...
| disable ()
| To disable the component, and set `disabled` property to true, this method triggers UIExtension.UIConsts.COMPONENT_EVENTS.DISABLE event. More...
| enable ()
| Enables component, and set `disabled` property to false, this method triggers UIExtension.UIConsts.COMPONENT_EVENTS.ENABLE event. More...
| findClosestComponent (callback)
| Find the first ancestor in the component tree which passed the testing of callback. More...
| getClosestComponentByName (name)
| Find the first ancestor in the component tree which name is equal to the passing value. More...
| getClosestComponentByType (type)
| Find the first ancestor in the component tree which type is equal to the passing value. More...
| getComponentByName (name)
| This method returns an Component object representing the component whose name property matches the specified string. If there are more than one components matched, only the first one is taken. More...
PDFUI | getPDFUI ()
| Get PDFUI instance, PDFUI instance is passing into a component after constructed. So that an undefined value will be returned in constructoring lifecycle. More...
| getRoot ()
| Get root component of this component tree. More...
| hide ()
| Hide component and set `isVisible` property to false, this method UIExtension.UIConsts.COMPONENT_EVENTS.HIDDEN event. More...
| index ()
| Get the index of this component in parent. More...
| isContainer ()
| Method used to detect whether a component is a container. More...
| isStateKept (kind=KeepStateKind.VISIBILITY)
| Check if state is kept or not. More...
| keepState (kind=KeepStateKind.VISIBILITY)
| This method is used to keep the current state of the component unchanged. After the state is kept, the show/hide methods of the component will no longer take effect unless the keep-state is revoked. More...
| localize (localizer=this.localizer)
| Localize message with the value of the data-i18n attribute above the DOM element of component recursively. More...
| nextSiblings ()
| This method returns the component immediately following this component's parent children list, or returns null if this component is the last in that list. More...
| off (eventName, listener)
| Unregister event handler of a geven event type, if no handler function specified, all handler of this given event type will be removed. More...
| on (eventName, listener)
| Registers an event handler to a specific event type on the component. More...
| once (eventName, listener)
| Registers an event handler to a specific event type on the component, but difference from Component#on, this event handler will be triggered only once. More...
| postlink ()
| Lifecycle method: postlink. The postlink method is called after all of the children are parsed. More...
| prelink ()
| Lifecycle method: prelink. The prelink method is called after component is rendered. More...
| previousSiblings ()
| This method returns the component immediately preceding this component's parent children list, or returns null if this component is the first in that list. More...
| querySelector (selector)
| Queries the first result returned from `querySelectorAll`. More...
| querySelectorAll (selectors)
| Returns all components that match the specified selector string. selector syntax: More...
| remove ()
| Remove component from its parent, and triggers UIExtension.UIConsts.COMPONENT_EVENTS.REMOVED event. More...
| removeElement ()
| Remove element from DOM tree.
| revokeKeepState (kind=KeepStateKind.VISIBILITY)
| Revoke keep-state and makes the show/hide methods back to normal. More...
| show (showParams)
| Shows up component, and set `isVisible` property to true, this method triggers UIExtension.UIConsts.COMPONENT_EVENTS.SHOWN event. More...
| trigger (eventName,...data)
| Calls each of the listeners registered for a given event type. More...

## Protected Member Functions
| doInsert (child, index)
| Insert component into this container component at the specified index. More...
| doInsertAll (children, index)
| Insert components array into this container component at the specified index. More...
| getContainerElement ()
| rerenderChildren ()
| Rerender all children of this container component, it's called after children removed or added,.
Protected Member Functions inherited from Component
| constructor (options, module, localizer)
| createDOMElement ()
| This method creates a HTMLElement as the root element for this component. More...
| doActive ()
| This method is called after the component is activated. It is used to update the rendering effect after the component is activated. It is usefull to override this method to customize the rendering.
| doDeactive ()
| This method is called after the component is deactivated. It is used to update the rendering effect after the component is deactivated. It is usefull to override this method to customize the rendering.
| doDestroy ()
| This method is called to destroy the component, You should override this method for your custom component to write your customize destroy logic.
| doDisable (reason='')
| This method is called after the component is disabled. It is used to update the rendering effect after the component is disabled. It is usefull to override this method to customize the rendering.
| doEnable (reason='')
| This method is called after the component is enabled. It is used to update the rendering effect after the component is enabled. It is usefull to override this method to customize the rendering.
| doHidden ()
| This method is called to hide the DOM element of this component. It is usefull to override this method to customize the hidding logic.
| doShown ()
| This method is called to show the DOM element of this component. It is usefull to override this method to customize the showing logic.
| mounted ()
| Lifecycle method: mounted. The mounted method is called after the element of component is appended into the DOM tree. More...
| render ()
| Lifecycle method: render. The render method is always been called to create DOM element of the component, it's called after createDOMElement called and before calling prelink. More...

## Additional Inherited Members
Static Public Member Functions inherited from Component
static | extend (name, def, statics={})
static | getName ()
| This method returns a string identifies as the name of a component type that you can use this string as the tag name in the template. Each component must override this static method so that the template can get this component class. More...
Public Attributes inherited from Component
boolean | canBeDisabled
| Whether or not this component can be disabled. All of the component can be disabled by default unless you manually set the value of this property to true. More...
Controller | controller
| The controller instanceof of this component. The controller is specified externally and that contains the business logic of this component. More...
boolean | disabled
| Whether or not this component is enabled. Components are enabled by default, and must be enable to recieve user inut or generate events. More...
HTMLElement | element
| The root DOM element object of this component. More...
boolean | isActive
| Whether or not this component is active.Active is a complicated state, it can prepresent different interaction states in different component. More...
boolean | isVisible
| Whether or not this component is visible. Expect for layers, Most components are initially visible. More...
string | name
| The name of this component. More...
ContainerComponent | parent
| The parent of this component. More...

## Detailed Description

An container is a component to organize widgets. You need to inherit this class and implement some necessary methods to customize your own container components.
The features that distinguish from widgets are following:

1. Widget cannot have children
2. If disable or enable method of container component is called, the all children of that will be disabled or enabled. You can customize this behavior by overriding doDisable and doEnable methods together.
3. Widget must inherit from `Component` but container component must inherit from `ContainerComponent`

For more details on usage please visit this page: /examples/UIExtension/tutorials/container.html

ContainerComponent

Examples:
  /builds/foxit/phantom/cloud/phantompdf_online/foxitwebsdk/doxygen/workspace/headerfiles/uix-addons/thumbnail/thumbUIComponent.js.

## Member Function Documentation

## ◆ append()

append | ( |  | child,
|  |  | fragments
| ) |  |
| inline

Append a component or a template into this container component.

Parameters

  child | Component|string - the component to be appended or the template string.
  [fragments] | UIFragmentOptions[] - the fragment options for parsing the template string.

Returns
  Component - the component that is created from the template

## ◆ childAt()

childAt | ( |  | index | ) |
| inline

Get the specific child component at the given zero-based `index`. Returns `undefined` if the index is out of range.

Parameters

  index | number

Returns
  Component

## ◆ children()

children | ( |  | ) |
| inline

Get all children of this container component.

Returns
  `Component[]` - all children components

## ◆ childrenCount()

ContainerComponent::childrenCount | ( |  | ) |
| inline

Returns the number of children in this container component.

Returns
  number - count of children components

## ◆ doInsert()

doInsert | ( |  | child,
|  |  | index
| ) |  |
| inline protected

Insert component into this container component at the specified index.

Parameters

  component | Component -
  index | number - if index less then or equal to 0, the component shoud insert into the first place, or if index great then the children's count, the component should be inserted into the end.

## ◆ doInsertAll()

doInsertAll | ( |  | children,
|  |  | index
| ) |  |
| inline protected

Insert components array into this container component at the specified index.

Parameters

  children | `Component[]`
  index | number

## ◆ first()

first | ( |  | ) |
| inline

Get the first child fom this container component, if there is no children, null will returned.

Returns
  Component

## ◆ getContainerElement()

ContainerComponent::getContainerElement | ( |  | ) |
| inline protected

Returns
  HTMLElement

Examples:
  /builds/foxit/phantom/cloud/phantompdf_online/foxitwebsdk/doxygen/workspace/headerfiles/uix-addons/thumbnail/thumbUIComponent.js.

## ◆ indexOf()

indexOf | ( |  | child | ) |
| inline

Get the index of an child component.

Parameters

  child | `Component` - child component instance

Returns
  number - this function returns -1 if not contains this child component.

## ◆ insert()

ContainerComponent::insert | ( |  | child,
|  |  | index,
|  |  | fragments
| ) |  |
| inline

Inserts a component instance or component template.
Example:

pdfui.getComponentByName('home-tab-group-hand')
.then(function(groupComponent) {
groupComponent.insert(
'<xbutton icon-class="fv__icon-toolbar-hand" name="insert-button-name"></xbutton>',
0,
[{
target: 'insert-button-name',
config: {
callback: function() {
alert('button clicked');
}
}
}]
);
})

.

Parameters

  child | `Component`|string|Node
  index | number
  fragments | `UIFragmentOptions[]`

## ◆ insertAll()

insertAll | ( |  | children,
|  |  | index
| ) |  |
| inline

Inserts a set of components to the specified index.

Parameters

  children | `Component[]`
  index | number

## ◆ last()

last | ( |  | ) |
| inline

Get the last child from this container component.

Returns
  Component

## ◆ prepend()

prepend | ( |  | child,
|  |  | fragments
| ) |  |
| inline

Prepend a component or a template into this container component.

Parameters

  child | Component|string - the component to be prepended or the template string.
  [fragments] | UIFragmentOptions[] - the fragment options for parsing the template string.

Returns
  Component - the component that is created from the template

## ◆ removeChild()

removeChild | ( |  | child | ) |
| inline

Remove a child from this component and trigger UIExtension.UIConsts.COMPONENT_EVENTS.REMOVED event;.

component.on(UIExtension.UIConsts.COMPONENT_EVENTS.REMOVED,function(){
})

Parameters

  child | Component

## ◆ size()

size | ( |  | ) |
| inline

The number of children in this container component.

Deprecated:
  use childrenCount instead

Returns
  number

Examples:
  /builds/foxit/phantom/cloud/phantompdf_online/foxitwebsdk/doxygen/workspace/headerfiles/uix-addons/thumbnail/thumbUIComponent.js.

@2025 Foxit Software Incorporated. All rights reserved.